package models

//供应商联系人
type SpSupplierContacts struct {
	ID           int64  `gorm:"column:id" json:"id" form:"id"`
	Name         string `gorm:"column:name" json:"name" form:"name"`
	Phone        string `gorm:"column:phone" json:"phone" form:"phone"`
	Address      string `gorm:"column:address" json:"address" form:"address"`
	IsFirst      int64  `gorm:"column:is_first" json:"is_first" form:"is_first"`
	SupplierCode string `gorm:"column:supplier_code" json:"supplier_code" form:"supplier_code"`
	UserOrgId    int64  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status       int64  `gorm:"column:status" json:"status" form:"status"`
	Ctime        int64  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime        int64  `gorm:"column:mtime" json:"mtime" form:"mtime"`
}

func (SpSupplierContacts) TableName() string {
	return "xt_supplier_contacts"
}

type SpBaseDrug struct {
	ID                int64                  `gorm:"column:id" json:"id" form:"id"`
	DrugName          string                 `gorm:"column:drug_name" json:"drug_name" form:"drug_name"`
	DrugCategory      int64                  `gorm:"column:drug_category" json:"drug_category" form:"drug_category"`
	DrugSpec          string                 `gorm:"column:drug_spec" json:"drug_spec" form:"drug_spec"`
	DrugType          int64                  `gorm:"column:drug_type" json:"drug_type" form:"drug_type"`
	MaxUnit           string                 `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinNumber         int64                  `gorm:"column:min_number" json:"min_number" form:"min_number"`
	MinUnit           string                 `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	Dose              string                 `gorm:"column:dose" json:"dose" form:"dose"`
	DoseUnit          string                 `gorm:"column:dose_unit" json:"dose_unit" form:"dose_unit"`
	DrugDose          float64                `gorm:"column:drug_dose" json:"drug_dose" form:"drug_dose"`
	DrugDoseUnit      int64                  `gorm:"column:drug_dose_unit" json:"drug_dose_unit" form:"drug_dose_unit"`
	Manufacturer      int64                  `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	OrgId             int64                  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	Number            string                 `gorm:"column:number" json:"number" form:"number"`
	LastPrice         float64                `gorm:"column:last_price" json:"last_price" form:"last_price"`
	DrugWarehouseInfo []*SpDrugWarehouseInfo `gorm:"ForeignKey:DrugId;AssociationForeignKey:ID" json:"drug_warehouse_info"`
	DrugStatus        string                 `gorm:"column:drug_status" json:"drug_status" form:"drug_status"`
	MinPrice          float64                `gorm:"column:min_price" json:"min_price" form:"min_price"`
}

func (SpBaseDrug) TableName() string {
	return "xt_base_drug"
}

type SpGoodInformation struct {
	ID                int64              `gorm:"column:id" json:"id" form:"id"`
	SpecificationName string             `gorm:"column:specification_name" json:"specification_name" form:"specification_name"`
	GoodTypeId        int64              `gorm:"column:good_type_id" json:"good_type_id" form:"good_type_id"`
	GoodUnit          int64              `gorm:"column:good_unit" json:"good_unit" form:"good_unit"`
	Manufacturer      int64              `gorm:"column:manufacturer" json:"manufacturer" form:"manufacturer"`
	OrgId             int64              `gorm:"column:org_id" json:"org_id" form:"org_id"`
	GoodName          string             `gorm:"column:good_name" json:"good_name" form:"good_name"`
	PackingUnit       string             `gorm:"column:packing_unit" json:"packing_unit" form:"packing_unit"`
	BuyPrice          float64            `gorm:"column:buy_price" json:"buy_price" form:"buy_price"`
	GoodStatus        string             `gorm:"column:good_status" json:"good_status" form:"good_status"`
	GoodWarehouseInfo []*SpWarehouseInfo `gorm:"ForeignKey:GoodId;AssociationForeignKey:ID" json:"good_warehouse_info"`
	Number            string             `gorm:"column:number" json:"number" form:"number"`
	RetailPrice       float64            `gorm:"column:retail_price" json:"retail_price" form:"retail_price"`
}

func (SpGoodInformation) TableName() string {
	return "xt_good_information"
}

type SpWarehouseInfo struct {
	ID                        int64 `gorm:"column:id" json:"id" form:"id"`
	GoodId                    int64 `gorm:"column:good_id" json:"good_id" form:"good_id"`
	StockCount                int64 `gorm:"column:stock_count" json:"stock_count" form:"stock_count"`
	Status                    int64 `gorm:"column:status" json:"status" form:"status"`
	OrgId                     int64 `gorm:"column:org_id" json:"org_id" form:"org_id"`
	SupplyWarehouseDetailInfo int64 `gorm:"column:supply_warehouse_detail_info" json:"supply_warehouse_detail_info" form:"supply_warehouse_detail_info"`
	SupplyWarehouseId         int64 `gorm:"column:supply_warehouse_id" json:"supply_warehouse_id" form:"supply_warehouse_id"`
}

func (SpWarehouseInfo) TableName() string {
	return "xt_warehouse_info"
}

type SpDrugWarehouseInfo struct {
	ID                        int64  `gorm:"column:id" json:"id" form:"id"`
	DrugId                    int64  `gorm:"column:drug_id" json:"drug_id" form:"drug_id"`
	MaxUnit                   string `gorm:"column:max_unit" json:"max_unit" form:"max_unit"`
	MinUnit                   string `gorm:"column:min_unit" json:"min_unit" form:"min_unit"`
	StockMaxNumber            int64  `gorm:"column:stock_max_number" json:"stock_max_number" form:"stock_max_number"`
	StockMinNumber            int64  `gorm:"column:stock_min_number" json:"stock_min_number" form:"stock_min_number"`
	BatchNumber               string `gorm:"column:batch_number" json:"batch_number" form:"batch_number"`
	Status                    int64  `gorm:"column:status" json:"status" form:"status"`
	OrgId                     int64  `gorm:"column:org_id" json:"org_id" form:"org_id"`
	SupplyWarehouseDetailInfo int64  `gorm:"column:supply_warehouse_detail_info" json:"supply_warehouse_detail_info" form:"supply_warehouse_detail_info"`
	SupplyWarehouseId         int64  `gorm:"column:supply_warehouse_id" json:"supply_warehouse_id" form:"supply_warehouse_id"`
}

func (SpDrugWarehouseInfo) TableName() string {
	return "xt_drug_warehouse_info"
}

type SpSupplierName struct {
	ID           int64   `gorm:"column:id" json:"id" form:"id"`
	SupplierCode string  `gorm:"column:supplier_code" json:"supplier_code" form:"supplier_code"`
	SupplierName string  `gorm:"column:supplier_name" json:"supplier_name" form:"supplier_name"`
	SupplierType int64   `gorm:"column:supplier_type" json:"supplier_type" form:"supplier_type"`
	VatRate      float64 `gorm:"column:vat_rate" json:"vat_rate" form:"vat_rate"`
	Number       string  `gorm:"column:number" json:"number" form:"number"`
	Bank         string  `gorm:"column:bank" json:"bank" form:"bank"`
	BankAccount  string  `gorm:"column:bank_account" json:"bank_account" form:"bank_account"`
	UserOrgId    int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status       int64   `gorm:"column:status" json:"status" form:"status"`
	ContactsId   int64   `gorm:"column:contacts_id" json:"contacts_id" form:"contacts_id"`
	Ctime        int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime        int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Creater      int64   `gorm:"column:creater" json:"creater" form:"creater"`
	Modify       int64   `gorm:"column:modify" json:"modify" form:"modify"`
}

func (SpSupplierName) TableName() string {
	return "xt_supplier_name"
}

type SupplierWarehousingInfoOrder struct {
	ID                      int64   `gorm:"column:id" json:"id" form:"id"`
	OrderNumber             string  `gorm:"column:order_number" json:"order_number" form:"order_number"`
	IsSource                int64   `gorm:"column:is_source" json:"is_source" form:"is_source"`
	Count                   int64   `gorm:"column:count" json:"count" form:"count"`
	Price                   float64 `gorm:"column:price" json:"price" form:"price"`
	Amount                  float64 `gorm:"column:amount" json:"amount" form:"amount"`
	Remark                  string  `gorm:"column:remark" json:"remark" form:"remark"`
	UserOrgId               int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Ctime                   int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Status                  int64   `gorm:"column:status" json:"status" form:"status"`
	Mtime                   int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	WarehousingId           int64   `gorm:"column:warehousing_id" json:"warehousing_id" form:"warehousing_id"`
	ProjectId               int64   `gorm:"column:project_id" json:"project_id" form:"project_id"`
	SupplyLicenseNumber     string  `gorm:"column:supply_license_number" json:"supply_license_number" form:"supply_license_number"`
	SupplyType              string  `gorm:"column:supply_type" json:"supply_type" form:"supply_type"`
	SupplySpecificationName string  `gorm:"column:supply_specification_name" json:"supply_specification_name" form:"supply_specification_name"`
	SupplyTotal             string  `gorm:"column:supply_total" json:"supply_total" form:"supply_total"`
	SupplyManufacturer      string  `gorm:"column:supply_manufacturer" json:"supply_manufacturer" form:"supply_manufacturer"`
	Name                    string  `gorm:"column:name" json:"name" form:"name"`
	SupplyUnit              string  `gorm:"column:supply_unit" json:"supply_unit" form:"supply_unit"`
	ManufacturerId          int64   `gorm:"column:manufacturer_id" json:"manufacturer_id" form:"manufacturer_id"`
}

func (SupplierWarehousingInfoOrder) TableName() string {
	return "xt_supplier_warehousing_info_order"
}

type SupplierWarehouseInfo struct {
	ID               int64   `gorm:"column:id" json:"id" form:"id"`
	Number           string  `gorm:"column:number" json:"number" form:"number"`
	UserOrgId        int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Creater          int64   `gorm:"column:creater" json:"creater" form:"creater"`
	Ctime            int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime            int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status           int64   `gorm:"column:status" json:"status" form:"status"`
	RecordDate       int64   `gorm:"column:record_date" json:"record_date" form:"record_date"`
	IsCheck          int64   `gorm:"column:is_check" json:"is_check" form:"is_check"`
	RateOfConcession float64 `gorm:"column:rate_of_concession" json:"rate_of_concession" form:"rate_of_concession"`
	DiscountAmount   float64 `gorm:"column:discount_amount" json:"discount_amount" form:"discount_amount"`
	DocumentDate     int64   `gorm:"column:document_date" json:"document_date" form:"document_date"`
	DeliveryDate     int64   `gorm:"column:delivery_date" json:"delivery_date" form:"delivery_date"`
	SupplierId       int64   `gorm:"column:supplier_id" json:"supplier_id" form:"supplier_id"`
	Checker          int64   `gorm:"column:checker" json:"checker" form:"checker"`
	CheckTime        int64   `gorm:"column:check_time" json:"check_time" form:"check_time"`
	IsWarehouse      int64   `gorm:"column:is_warehouse" json:"is_warehouse" form:"is_warehouse"`
	ReturnRemake     string  `gorm:"column:return_remake" json:"return_remake" form:"return_remake"`
}

func (SupplierWarehouseInfo) TableName() string {
	return "xt_supplier_warehouse_info"
}

type VmSupplierWarehouseInfo struct {
	ID                           int64                           `gorm:"column:id" json:"id" form:"id"`
	Number                       string                          `gorm:"column:number" json:"number" form:"number"`
	UserOrgId                    int64                           `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Creater                      int64                           `gorm:"column:creater" json:"creater" form:"creater"`
	Ctime                        int64                           `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                        int64                           `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status                       int64                           `gorm:"column:status" json:"status" form:"status"`
	RecordDate                   int64                           `gorm:"column:record_date" json:"record_date" form:"record_date"`
	IsCheck                      int64                           `gorm:"column:is_check" json:"is_check" form:"is_check"`
	RateOfConcession             float64                         `gorm:"column:rate_of_concession" json:"rate_of_concession" form:"rate_of_concession"`
	DiscountAmount               float64                         `gorm:"column:discount_amount" json:"discount_amount" form:"discount_amount"`
	DocumentDate                 int64                           `gorm:"column:document_date" json:"document_date" form:"document_date"`
	DeliveryDate                 int64                           `gorm:"column:delivery_date" json:"delivery_date" form:"delivery_date"`
	SupplierId                   int64                           `gorm:"column:supplier_id" json:"supplier_id" form:"supplier_id"`
	Checker                      int64                           `gorm:"column:checker" json:"checker" form:"checker"`
	CheckTime                    int64                           `gorm:"column:check_time" json:"check_time" form:"check_time"`
	IsWarehouse                  int64                           `gorm:"column:is_warehouse" json:"is_warehouse" form:"is_warehouse"`
	SupplierWarehousingInfoOrder []*SupplierWarehousingInfoOrder `gorm:"ForeignKey:WarehousingId;AssociationForeignKey:ID" json:"orderInfo"`
	SpSupplierWarehouseOut       []*SpSupplierWarehouseOut       `gorm:"ForeignKey:WarehousingId;AssociationForeignKey:ID" json:"orderOut"`
}

func (VmSupplierWarehouseInfo) TableName() string {
	return "xt_supplier_warehouse_info"
}

type SpSupplierWarehousingOutOrder struct {
	ID                      int64                  `gorm:"column:id" json:"id" form:"id"`
	OrderNumber             string                 `gorm:"column:order_number" json:"order_number" form:"order_number"`
	ProjectId               int64                  `gorm:"column:project_id" json:"project_id" form:"project_id"`
	IsSource                int64                  `gorm:"column:is_source" json:"is_source" form:"is_source"`
	Count                   int64                  `gorm:"column:count" json:"count" form:"count"`
	Price                   float64                `gorm:"column:price" json:"price" form:"price"`
	Amount                  float64                `gorm:"column:amount" json:"amount" form:"amount"`
	Remark                  string                 `gorm:"column:remark" json:"remark" form:"remark"`
	IsCheck                 int64                  `gorm:"column:is_check" json:"is_check" form:"is_check"`
	UserOrgId               int64                  `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Status                  int64                  `gorm:"column:status" json:"status" form:"status"`
	Ctime                   int64                  `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                   int64                  `gorm:"column:mtime" json:"mtime" form:"mtime"`
	WarehouseOutId          int64                  `gorm:"column:warehouse_out_id" json:"warehouse_out_id" form:"warehouse_out_id"`
	Type                    int64                  `gorm:"column:type" json:"type" form:"type"`
	SupplyBatchNumber       string                 `gorm:"column:supply_batch_number" json:"supply_batch_number" form:"supply_batch_number"`
	SupplyProductDate       int64                  `gorm:"column:supply_product_date" json:"supply_product_date" form:"supply_product_date"`
	SupplyExpiryDate        int64                  `gorm:"column:supply_expiry_date" json:"supply_expiry_date" form:"supply_expiry_date"`
	WarehousingId           int64                  `gorm:"column:warehousing_id" json:"warehousing_id" form:"warehousing_id"`
	WarehouseInfoId         int64                  `gorm:"column:warehouse_info_id" json:"warehouse_info_id" form:"warehouse_info_id"`
	SupplyType              string                 `gorm:"column:supply_type" json:"supply_type" form:"supply_type"`
	SupplySpecificationName string                 `gorm:"column:supply_specification_name" json:"supply_specification_name" form:"supply_specification_name"`
	SupplyTotal             string                 `gorm:"column:supply_total" json:"supply_total" form:"supply_total"`
	SupplyManufacturer      string                 `gorm:"column:supply_manufacturer" json:"supply_manufacturer" form:"supply_manufacturer"`
	Name                    string                 `gorm:"column:name" json:"name" form:"name"`
	SupplyUnit              string                 `gorm:"column:supply_unit" json:"supply_unit" form:"supply_unit"`
	ManufacturerId          int64                  `gorm:"column:manufacturer_id" json:"manufacturer_id" form:"manufacturer_id"`
	SupplyLicenseNumber     string                 `gorm:"column:supply_license_number" json:"supply_license_number" form:"supply_license_number"`
	GoodNumber              string                 `gorm:"column:good_number" json:"good_number" form:"good_number"`
	MinPrice                float64                `gorm:"column:min_price" json:"min_price" form:"min_price"`
	IsWarehosue             int64                  `gorm:"column:is_warehouse" json:"is_warehouse" form:"is_warehouse"`
	GoodWarehouseInfo       []*SpWarehouseInfo     `gorm:"ForeignKey:ProjectId;AssociationForeignKey:GoodId" json:"good_warehouse_info"`
	DrugWarehouseInfo       []*SpDrugWarehouseInfo `gorm:"ForeignKey:ProjectId;AssociationForeignKey:DrugId" json:"drug_warehouse_info"`
	SpBaseDrug              XtBaseDrug             `gorm:"ForeignKey:ProjectId;AssociationForeignKey:ID" json:"drug"`
}

func (SpSupplierWarehousingOutOrder) TableName() string {
	return "xt_supplier_warehousing_out_order"
}

type SpSupplierWarehouseOut struct {
	ID                            int64                            `gorm:"column:id" json:"id" form:"id"`
	Number                        string                           `gorm:"column:number" json:"number" form:"number"`
	UserOrgId                     int64                            `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Creater                       int64                            `gorm:"column:creater" json:"creater" form:"creater"`
	Ctime                         int64                            `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                         int64                            `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status                        int64                            `gorm:"column:status" json:"status" form:"status"`
	RecordDate                    int64                            `gorm:"column:record_date" json:"record_date" form:"record_date"`
	IsCheck                       int64                            `gorm:"column:is_check" json:"is_check" form:"is_check"`
	WarehousingId                 int64                            `gorm:"column:warehousing_id" json:"warehousing_id" form:"warehousing_id"`
	GoodNumber                    string                           `gorm:"column:good_number" json:"good_number" form:"good_number"`
	Arrearage                     float64                          `gorm:"column:arrearage" json:"arrearage" form:"arrearage"`
	Payment                       float64                          `gorm:"column:payment" json:"payment" form:"payment"`
	RateOfConcession              float64                          `gorm:"column:rate_of_concession" json:"rate_of_concession" form:"rate_of_concession"`
	DiscountAmount                float64                          `gorm:"column:discount_amount" json:"discount_amount" form:"discount_amount"`
	DocumentDate                  int64                            `gorm:"column:document_date" json:"document_date" form:"document_date"`
	SupplierId                    int64                            `gorm:"column:supplier_id" json:"supplier_id" form:"supplier_id"`
	Checker                       int64                            `gorm:"column:checker" json:"checker" form:"checker"`
	CheckTime                     int64                            `gorm:"column:check_time" json:"check_time" form:"check_time"`
	ReturnRemake                  string                           `gorm:"column:return_remake" json:"return_remake" form:"return_remake"`
	SpSupplierWarehousingOutOrder []*SpSupplierWarehousingOutOrder `gorm:"ForeignKey:warehouse_out_id;AssociationForeignKey:ID" json:"order"`
}

func (SpSupplierWarehouseOut) TableName() string {
	return "xt_supplier_warehouse_out"
}

type VmSupplierWarehouseOut struct {
	ID                               int64                               `gorm:"column:id" json:"id" form:"id"`
	Number                           string                              `gorm:"column:number" json:"number" form:"number"`
	UserOrgId                        int64                               `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Creater                          int64                               `gorm:"column:creater" json:"creater" form:"creater"`
	Ctime                            int64                               `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                            int64                               `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status                           int64                               `gorm:"column:status" json:"status" form:"status"`
	RecordDate                       int64                               `gorm:"column:record_date" json:"record_date" form:"record_date"`
	IsCheck                          int64                               `gorm:"column:is_check" json:"is_check" form:"is_check"`
	WarehousingId                    int64                               `gorm:"column:warehousing_id" json:"warehousing_id" form:"warehousing_id"`
	GoodNumber                       string                              `gorm:"column:good_number" json:"good_number" form:"good_number"`
	Arrearage                        float64                             `gorm:"column:arrearage" json:"arrearage" form:"arrearage"`
	Payment                          float64                             `gorm:"column:payment" json:"payment" form:"payment"`
	RateOfConcession                 float64                             `gorm:"column:rate_of_concession" json:"rate_of_concession" form:"rate_of_concession"`
	DiscountAmount                   float64                             `gorm:"column:discount_amount" json:"discount_amount" form:"discount_amount"`
	DocumentDate                     int64                               `gorm:"column:document_date" json:"document_date" form:"document_date"`
	SupplierId                       int64                               `gorm:"column:supplier_id" json:"supplier_id" form:"supplier_id"`
	Checker                          int64                               `gorm:"column:checker" json:"checker" form:"checker"`
	CheckTime                        int64                               `gorm:"column:check_time" json:"check_time" form:"check_time"`
	SpSupplierWarehousingOutOrder    []*SpSupplierWarehousingOutOrder    `gorm:"ForeignKey:warehouse_out_id;AssociationForeignKey:ID" json:"orderOut"`
	SpSupplierWarehousingCancelOrder []*SpSupplierWarehousingCancelOrder `gorm:"ForeignKey:warehouse_out_id;AssociationForeignKey:ID" json:"cancelOut"`
}

func (VmSupplierWarehouseOut) TableName() string {
	return "xt_supplier_warehouse_out"
}

type VSpSupplierWarehousingOutOrder struct {
	ID             int64  `gorm:"column:id" json:"id" form:"id"`
	OrderNumber    string `gorm:"column:order_number" json:"order_number" form:"order_number"`
	ProjectId      int64  `gorm:"column:project_id" json:"project_id" form:"project_id"`
	Count          int64  `gorm:"column:count" json:"count" form:"count"`
	Status         int64  `gorm:"column:status" json:"status" form:"status"`
	SupplyUnit     string `gorm:"column:supply_unit" json:"supply_unit" form:"supply_unit"`
	IsSource       int64  `gorm:"column:is_source" json:"is_source" form:"is_source"`
	WarehousingId  int64  `gorm:"column:warehousing_id" json:"warehousing_id" form:"warehousing_id"`
	IsWarehosue    int64  `gorm:"column:is_warehosue" json:"is_warehosue" form:"is_warehosue"`
	WarehouseOutId int64  `gorm:"column:warehouse_out_id" json:"warehouse_out_id" form:"warehouse_out_id"`
}

func (VSpSupplierWarehousingOutOrder) TableName() string {
	return "xt_supplier_warehousing_out_order"
}

type VSupplierWarehousingInfoOrder struct {
	Count      int64  `gorm:"column:count" json:"count" form:"count"`
	ProjectId  int64  `gorm:"column:project_id" json:"project_id" form:"project_id"`
	SupplyUnit string `gorm:"column:supply_unit" json:"supply_unit" form:"supply_unit"`
	IsSource   int64  `gorm:"column:is_source" json:"is_source" form:"is_source"`
}

func (VSupplierWarehousingInfoOrder) TableName() string {
	return "xt_supplier_warehousing_info_order"
}

type SpSupplierWarehouseCancel struct {
	ID               int64   `gorm:"column:id" json:"id" form:"id"`
	Number           string  `gorm:"column:number" json:"number" form:"number"`
	UserOrgId        int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Creater          int64   `gorm:"column:creater" json:"creater" form:"creater"`
	Ctime            int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime            int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status           int64   `gorm:"column:status" json:"status" form:"status"`
	RecordDate       int64   `gorm:"column:record_date" json:"record_date" form:"record_date"`
	IsCheck          int64   `gorm:"column:is_check" json:"is_check" form:"is_check"`
	WarehouseOutId   int64   `gorm:"column:warehouse_out_id" json:"warehouse_out_id" form:"warehouse_out_id"`
	RateOfConcession float64 `gorm:"column:rate_of_concession" json:"rate_of_concession" form:"rate_of_concession"`
	DiscountAmount   float64 `gorm:"column:discount_amount" json:"discount_amount" form:"discount_amount"`
	DocumentDate     int64   `gorm:"column:document_date" json:"document_date" form:"document_date"`
	SupplierId       int64   `gorm:"column:supplier_id" json:"supplier_id" form:"supplier_id"`
	Checker          int64   `gorm:"column:checker" json:"checker" form:"checker"`
	CheckTime        int64   `gorm:"column:check_time" json:"check_time" form:"check_time"`
	Arrearage        float64 `gorm:"column:arrearage" json:"arrearage" form:"arrearage"`
	Payment          float64 `gorm:"column:payment" json:"payment" form:"payment"`
	ReturnRemark     string  `gorm:"column:return_remark" json:"return_remark" form:"return_remark"`
}

func (SpSupplierWarehouseCancel) TableName() string {
	return "xt_supplier_warehouse_cancel"
}

type SpSupplierWarehousingCancelOrder struct {
	ID                        int64   `gorm:"column:id" json:"id" form:"id"`
	ManufacturerId            int64   `gorm:"column:manufacturer_id" json:"manufacturer_id" form:"manufacturer_id"`
	OrderNumber               string  `gorm:"column:order_number" json:"order_number" form:"order_number"`
	ProjectId                 int64   `gorm:"column:project_id" json:"project_id" form:"project_id"`
	GoodNumber                string  `gorm:"column:good_number" json:"good_number" form:"good_number"`
	IsSource                  int64   `gorm:"column:is_source" json:"is_source" form:"is_source"`
	Count                     string  `gorm:"column:count" json:"count" form:"count"`
	Price                     float64 `gorm:"column:price" json:"price" form:"price"`
	Remark                    string  `gorm:"column:remark" json:"remark" form:"remark"`
	RateOfConcession          float64 `gorm:"column:rate_of_concession" json:"rate_of_concession" form:"rate_of_concession"`
	DiscountAmount            float64 `gorm:"column:discount_amount" json:"discount_amount" form:"discount_amount"`
	UserOrgId                 int64   `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Ctime                     int64   `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Status                    int64   `gorm:"column:status" json:"status" form:"status"`
	Mtime                     int64   `gorm:"column:mtime" json:"mtime" form:"mtime"`
	WarehouseCancelId         int64   `gorm:"column:warehouse_cancel_id" json:"warehouse_cancel_id" form:"warehouse_cancel_id"`
	Type                      int64   `gorm:"column:type" json:"type" form:"type"`
	ReturnNumber              string  `gorm:"column:return_number" json:"return_number" form:"return_number"`
	WarehouseOutId            int64   `gorm:"column:warehouse_out_id" json:"warehouse_out_id" form:"warehouse_out_id"`
	SupplySpecificationName   string  `gorm:"column:supply_specification_name" json:"supply_specification_name" form:"supply_specification_name"`
	SupplyType                string  `gorm:"column:supply_type" json:"supply_type" form:"supply_type"`
	SupplyTotal               string  `gorm:"column:supply_total" json:"supply_total" form:"supply_total"`
	SupplyManufacturer        string  `gorm:"column:supply_manufacturer" json:"supply_manufacturer" form:"supply_manufacturer"`
	Name                      string  `gorm:"column:name" json:"name" form:"name"`
	SupplyUnit                string  `gorm:"column:supply_unit" json:"supply_unit" form:"supply_unit"`
	SupplyLicenseNumber       string  `gorm:"column:supply_license_number" json:"supply_license_number" form:"supply_license_number"`
	SupplyBatchNumber         string  `gorm:"column:supply_batch_number" json:"supply_batch_number" form:"supply_batch_number"`
	SupplyProductDate         int64   `gorm:"column:supply_product_date" json:"supply_product_date" form:"supply_product_date"`
	SupplyExpiryDate          int64   `gorm:"column:supply_expiry_date" json:"supply_expiry_date" form:"supply_expiry_date"`
	WarehousingId             int64   `gorm:"column:warehousing_id" json:"warehousing_id" form:"warehousing_id"`
	WarehouseInfoId           int64   `gorm:"column:warehouse_info_id" json:"warehouse_info_id" form:"warehouse_info_id"`
	SourceCount               string  `gorm:"column:source_count" json:"source_count" form:"source_count"`
	SupplyWarehouseDetailInfo int64   `gorm:"column:supply_warehouse_detail_info" json:"supply_warehouse_detail_info" form:"supply_warehouse_detail_info"`
	SupplyCount               int64   `gorm:"column:supply_count" json:"supply_count" form:"supply_count"`
	DepositRate               float64 `gorm:"column:deposit_rate" json:"deposit_rate" form:"deposit_rate"`
}

func (SpSupplierWarehousingCancelOrder) TableName() string {
	return "xt_supplier_warehousing_cancel_order"
}

type VmSpSupplierWarehouseCancel struct {
	ID                               int64                               `gorm:"column:id" json:"id" form:"id"`
	Number                           string                              `gorm:"column:number" json:"number" form:"number"`
	UserOrgId                        int64                               `gorm:"column:user_org_id" json:"user_org_id" form:"user_org_id"`
	Creater                          int64                               `gorm:"column:creater" json:"creater" form:"creater"`
	Ctime                            int64                               `gorm:"column:ctime" json:"ctime" form:"ctime"`
	Mtime                            int64                               `gorm:"column:mtime" json:"mtime" form:"mtime"`
	Status                           int64                               `gorm:"column:status" json:"status" form:"status"`
	RecordDate                       int64                               `gorm:"column:record_date" json:"record_date" form:"record_date"`
	IsCheck                          int64                               `gorm:"column:is_check" json:"is_check" form:"is_check"`
	WarehouseOutId                   int64                               `gorm:"column:warehouse_out_id" json:"warehouse_out_id" form:"warehouse_out_id"`
	RateOfConcession                 float64                             `gorm:"column:rate_of_concession" json:"rate_of_concession" form:"rate_of_concession"`
	DiscountAmount                   float64                             `gorm:"column:discount_amount" json:"discount_amount" form:"discount_amount"`
	DocumentDate                     int64                               `gorm:"column:document_date" json:"document_date" form:"document_date"`
	SupplierId                       int64                               `gorm:"column:supplier_id" json:"supplier_id" form:"supplier_id"`
	Checker                          int64                               `gorm:"column:checker" json:"checker" form:"checker"`
	CheckTime                        int64                               `gorm:"column:check_time" json:"check_time" form:"check_time"`
	Arrearage                        float64                             `gorm:"column:arrearage" json:"arrearage" form:"arrearage"`
	Payment                          float64                             `gorm:"column:payment" json:"payment" form:"payment"`
	ReturnRemark                     string                              `gorm:"column:return_remark" json:"return_remark" form:"return_remark"`
	SpSupplierWarehousingCancelOrder []*SpSupplierWarehousingCancelOrder `gorm:"ForeignKey:warehouse_cancel_id;AssociationForeignKey:ID" json:"cancelOrder"`
}

func (VmSpSupplierWarehouseCancel) TableName() string {
	return "xt_supplier_warehouse_cancel"
}

type VmSpSupplierWarehousingOutOrder struct {
	ProjectId      int64  `gorm:"column:project_id" json:"project_id" form:"project_id"`
	IsSource       int64  `gorm:"column:is_source" json:"is_source" form:"is_source"`
	Count          int64  `gorm:"column:count" json:"count" form:"count"`
	WarehouseOutId int64  `gorm:"column:warehouse_out_id" json:"warehouse_out_id" form:"warehouse_out_id"`
	SupplyUnit     string `gorm:"column:supply_unit" json:"supply_unit" form:"supply_unit"`
}

func (VmSpSupplierWarehousingOutOrder) TableName() string {
	return "xt_supplier_warehousing_out_order"
}

type VmSpSupplierWarehousingCancelOrder struct {
	ProjectId   int64  `gorm:"column:project_id" json:"project_id" form:"project_id"`
	IsSource    int64  `gorm:"column:is_source" json:"is_source" form:"is_source"`
	Count       string `gorm:"column:count" json:"count" form:"count"`
	SupplyUnit  string `gorm:"column:supply_unit" json:"supply_unit" form:"supply_unit"`
	SupplyCount int64  `gorm:"column:supply_count" json:"supply_count" form:"supply_count"`
}

func (VmSpSupplierWarehousingCancelOrder) TableName() string {
	return "xt_supplier_warehousing_cancel_order"
}
